/******************************************************************************
 ** $Id: Signal.java 319 2011-02-23 00:18:53Z wmh $
 ** Diese Datei ist Bestandteil der Java-Quelltexte des Würfelspiels JaFuffy.
 ** Lauffähig ab Java 6.
 ******************************************************************************
 ** Copyright (C) Wolfgang Hauck <wolfgang.hauck@3kelvin.de>
 ******************************************************************************
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 2 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ******************************************************************************
 ** Die aktuellste Version von JaFuffy findet sich im Internet unter
 ** <http://jafuffy.3kelvin.de>.
 **
 ** Kommentare, Fehler oder Erweiterungswünsche bitte per E-Mail senden an
 ** <jafuffy@3kelvin.de>.
 ******************************************************************************/
package jafuffy;

import java.applet.Applet;
import java.applet.AudioClip;

import javax.swing.SwingUtilities;

/** Abspielen von Geräuschen. */
class Geraeusch {

    /**
     * @return Gibt an, ob Geräusch ausgegeben werden soll.
     */
    static boolean geraeusch() {
        return Eigenschaften.GLOBAL.aktiv("Geraeusche");
    }

    /** Geräusch, das abgespielt werden kann. */
    private final AudioClip clip;

    /**
     * Konstruktor.
     *
     * @param name
     *            Name der Ressource, die das Geräusch beschreibt.
     */
    Geraeusch(String name) {
        if (Ressource.soundsystem()) {
            clip = Applet.newAudioClip(Ressource.SOUND.url(name));
        } else {
            clip = null;
        }
    }

    /** Geräusch abspielen. */
    void play() {
        play(0);
    }

    /**
     * Falls Geräusche ausgegeben werden sollen: Pausiert und spielt danach ein Geräusch.
     *
     * @param pause
     *            Pause in Millisekunden
     */
    void play(final int pause) {
        if (clip != null && geraeusch()) {
            try {
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {
                        if (pause > 0) {
                            try {
                                Thread.sleep(pause);
                            } catch (InterruptedException ie) {
                                ie.printStackTrace();
                            }
                        }
                        clip.play();
                    }
                });
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
